<?php
/**
 * Copyright (c) 2020. Cart2Quote B.V. All rights reserved.
 * See COPYING.txt for license details.
 */

declare(strict_types=1);

namespace Cart2Quote\AmastyCompatability\Plugin\Checkout\Block;

use Amasty\CheckoutCore\Model\Quote\CheckoutInitialization;
use Magento\Checkout\Block\Onepage;
use Magento\Checkout\Model\Session;

/**
 * @since 3.0.5
 */
class OnepagePlugin
{
    /**
     * @var Session
     */
    private $checkoutSession;

    /**
     * @var CheckoutInitialization
     */
    private $checkoutInitialization;

    public function __construct(
        Session $checkoutSession,
        CheckoutInitialization $checkoutInitialization
    ) {
        $this->checkoutSession = $checkoutSession;
        $this->checkoutInitialization = $checkoutInitialization;
    }

    /**
     * Set initial quote value
     *
     * @param Onepage $subject
     */
    public function beforeGetJsLayout(Onepage $subject)
    {
        if (!$subject->getData('module_name') == 'Cart2Quote_Quotation') {
            $this->checkoutInitialization->initializeShipping($this->checkoutSession->getQuote());
        }
    }
}
